"use strict";

exports.__esModule = true;

var _SparkSqlFormatter = require("./languages/SparkSqlFormatter");

var _SparkSqlFormatter2 = _interopRequireDefault(_SparkSqlFormatter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

exports["default"] = {
    /**
     * Format whitespaces in a query to make it easier to read.
     *
     * @param {String} query
     * @param {Object} cfg
     *  @param {String} cfg.language Query language, default is Standard SQL
     *  @param {String} cfg.indent Characters used for indentation, default is "  " (2 spaces)
     *  @param {Object} cfg.params Collection of params for placeholder replacement
     * @return {String}
     */
    format: function format(query, cfg) {
        cfg = cfg || {};
        return new _SparkSqlFormatter2["default"](cfg).format(query);
    }
};
module.exports = exports["default"];